if 1
%-----------------------------------------------------------------------------------%
f = 0.1;   % Lorentzian factor for pseudo-voigt lineshape. 
%-----------------------------------------------------------------------------------%
if ~exist('J','var');         J = 4;                end;
%f ~exist('ptgpstr','var');   ptgpstr = 'C4v';      end;
if ~exist('T','var');         T = 2;                end;
if ~exist('Ei','var');        Ei = 50;              end;
if ~exist('freq','var');      freq = 250;           end;
if ~exist('Et','var');        Et = -10:0.1:50;      end;
if ~exist('lineshape','var'); lineshape = 'fgauss'; end;
%-----------------------------------------------------------------------------------%
k_B   = 1.3806505e-23;     % J/K     - Boltzmann constant
Q_e   = 1.60217653e-19;    % C       - Charge of electron
k_Be  = k_B/(Q_e/1000);    % meV/K   - Boltzmann constant
%-----------------------------------------------------------------------------------%

symstr = {'triclinic' 'monoclinic' 'C3' 'C3v' 'orthorhombic' 'C4h' 'C4v' 'hexagonal' 'cubic'}; ptgpstr = symstr{ceil(rand*9)};
ptgpstr = 'C3v'; J=4;

allowed = ptgp(ptgpstr);
B = {rand(1,5).*exp(-abs([-2:2])./2).*allowed{1}./200 rand(1,9).*exp(-abs([-4:4])./2).*allowed{2}./500 rand(1,13).*exp(-abs([-6:6])./2).*allowed{3}./1000};
Hcf = cf_hmltn(J,B);
E=eig(Hcf); E-min(E)
peaks = cflvls(Hcf,T,[0 1])
fwhm = chopem(peaks(:,1),Ei,freq);

for ind_p = 1:size(peaks,1)
  peak(:,ind_p) = feval(lineshape,Et,[peaks(ind_p,1) fwhm(ind_p) peaks(ind_p,2) f]);
end

for ind_Et = 1:length(Et)
  spec(ind_Et) = sum(peak(ind_Et,:));
end

%plot(Et,spec);
end

[V,E] = eig(Hcf);
ptgpstr
V(find(abs(V)<1e-2))=0
E = diag(E)'-min(min(E));

% Determines the multiplicity of levels
tE = E-mean(E); lvls = []; while(tE); idegen = find(abs(tE-tE(1))<1e-6); tE(idegen) = []; lvls = [lvls length(idegen)]; end
lvls
ldiff = mean(diff(find(B{3})))

jE = []; ijE=1; for i=1:length(lvls); jE(ijE:(ijE+lvls(i)-1)) = -ceil(length(lvls)/2)+i; ijE=ijE+lvls(i); end; jE
eig(Hcf)'
x=V*diag(jE)*V'
V
eig(Hcf)'
%Hcf
[V,E]=eig(Hcf([1 4 7],[1 4 7]))

%alpha = rand*pi
%beta = rand*pi
%x=[sin(alpha)*sin(beta) cos(alpha)*sin(beta) cos(beta)]
%nv=6; alpha = rand(1,nv-1)*pi; inv = 1; x = ones(1,nv); for i=nv:-1:2; x(i) = x(i)*cos(alpha(inv)); x(1:(i-1)) = x(1:(i-1)).*sin(alpha(inv)); inv=inv+1; end; x
%sum(x.^2)
%G=givens(3); x=G{1,2}*G{1,3}*G{2,3}*(sign(rand(3)-0.5).*eye(3))

if 0
Jmat = mag_op_j(J); Jx = Jmat(:,:,1); Jy = Jmat(:,:,2); Jz = Jmat(:,:,3);
%t=Jx*V
%vx*Jx
%[u,s,vx] = svd(Jx); u*s*vx'; is=1./diag(s); is(find(isinf(is)))=0; iJx = vx*diag(is)*u'; Vp=iJx*Jx*V
%t=(V'*Jx*V).*conj(V'*Jx*V); t(find(abs(t)<1e-3))=0
%Hcf = V*E*V'
Trans = ( (V'*Jx*V).*conj(V'*Jx*V) + (V'*Jy*V).*conj(V'*Jy*V) + (V'*Jz*V).*conj(V'*Jz*V) ); Trans(find(abs(Trans)<1e-3))=0; Trans./(max(Trans(:,1)))
%Trans = ( (Vp'*Jx*Vp).*conj(Vp'*Jx*Vp) + (Vp'*Jy*Vp).*conj(Vp'*Jy*Vp) + (Vp'*Jz*Vp).*conj(Vp'*Jz*Vp) ); Trans(find(abs(Trans)<1e-3))=0

% Calculates the partition function.
Z = sum(exp(-E./(k_Be*T)));

% Calculates the transition matrix elements at finite temperatures.
for ind = 1:length(E)
  Trans(:,ind) = Trans(:,ind) .* (exp(-E(ind)./(k_Be*T))/Z);
end
Trans./(max(Trans(:,1)))
end
